import sun.reflect.ReflectionFactory;

import java.io.Closeable;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Serializable;
import java.lang.reflect.Array;
import java.lang.reflect.Constructor;

public class Main {

    public static void main(String[] args) throws Exception {
        Class[] arrayTypes = new Class[] {
                boolean[].class,
                boolean[][].class,
                byte[].class,
                byte[][].class,
                char[].class,
                char[][].class,
                double[].class,
                double[][].class,
                float[].class,
                float[][].class,
                int[].class,
                int[][].class,
                long[].class,
                long[][].class,
                short[].class,
                short[][].class,
                Boolean[].class,
                Boolean[][].class,
                Byte[].class,
                Byte[][].class,
                Character[].class,
                Character[][].class,
                Double[].class,
                Double[][].class,
                Float[].class,
                Float[][].class,
                Integer[].class,
                Integer[][].class,
                Long[].class,
                Long[][].class,
                Short[].class,
                Short[][].class,
                String[].class,
                String[][].class,
                Void[].class,
                Void[][].class,
                Class[].class,
                Class[][].class,
                Object[].class,
                Object[][].class,
                Number[].class,
                Number[][].class,
                Comparable[].class,
                Comparable[][].class,
                Serializable[].class,
                Serializable[][].class,
                Cloneable[].class,
                Cloneable[][].class,
                Readable[].class,
                Readable[][].class,
                AutoCloseable[].class,
                AutoCloseable[][].class,
                Closeable[].class,
                Closeable[][].class,
                Appendable[].class,
                Appendable[][].class,
                PrintStream[].class,
                PrintStream[][].class,
                PrintWriter[].class,
                PrintWriter[][].class,
                Record[].class,
                Record[][].class,
                Enum[].class,
                Enum[][].class,
                Enum[][][].class
        };

        for (int i = 0; i < arrayTypes.length; i++) {
            Constructor<?> cons = java.lang.Object.class.getDeclaredConstructor((Class[]) null);
            cons = ReflectionFactory.getReflectionFactory().newConstructorForSerialization(arrayTypes[i], cons);
            System.out.println(cons.getParameterCount());
            Object o = Array.newInstance(arrayTypes[i].getComponentType(), 0);
            System.out.println(o.getClass().descriptorString());
        }

        System.out.println("\nDone.");
    }
}
